#include <QDir>
#include <QFile>
#include <QUrl>
#include <QRegExp>
#include <QTextStream>

#include "document.h"

Document::Document(PlaylistItem *item, QWidget *parent)
    : QWebView(parent)
{
    m_time = item->time();
    m_uri = item->uri();

    connect(&m_timer, SIGNAL(timeout()), this, SLOT(onTimeout()));
}

void Document::run()
{
    QString basePath = QString("file://") + QDir::homePath() + QString("/.linutop-kiosk/data/");

    QFile f(m_uri.mid(7));
    if(!f.open(QIODevice::ReadOnly))
       emit(end());
    QTextStream in(&f);
    QString html = in.readAll();
    f.close();

    setHtml(parseTemplate(html), QUrl(basePath));
    m_timer.start(1000 * m_time);
}

void Document::onTimeout()
{
    m_timer.stop();
    emit(end());
}

void Document::stop()
{
    m_timer.stop();
}

QString Document::parseTemplate(QString &html)
{
    QRegExp limageRx("<limage([^>]*)>(.*/)?([^/]+)</limage>");
    QString output = html.replace(limageRx, "<img src=\"\\3\" \\1/>");

    return html;
}
